/*
 * ioGame
 * Copyright (C) 2021 - 2023  渔民小镇 （262610965@qq.com、luoyizhu@gmail.com） . All Rights Reserved.
 * # iohao.com . 渔民小镇
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package com.iohao.mmo.common.provide.client;

import com.iohao.game.action.skeleton.protocol.wrapper.ByteValueList;
import com.iohao.game.external.client.AbstractInputCommandRegion;
import com.iohao.mmo.common.provide.cmd.CommonCmd;
import com.iohao.mmo.common.provide.kit.ItemTypeNodeKit;
import com.iohao.mmo.common.provide.kit.ItemNode;
import com.iohao.mmo.common.provide.proto.ShowItemMessage;
import lombok.extern.slf4j.Slf4j;

import java.util.stream.Collectors;

/**
 * @author 渔民小镇
 * @date 2023-08-15
 */
@Slf4j
public class CommonInputCommandRegion extends AbstractInputCommandRegion {
    @Override
    public void initInputCommand() {
        this.inputCommandCreate.cmd = CommonCmd.cmd;

        listenBroadcast(ByteValueList.class, result -> {

            String collect = result.toList(ShowItemMessage.class)
                    .stream()
                    .map(this::convert)
                    .map(ItemTypeNodeKit::toString)
                    .collect(Collectors.joining());

            log.info("获得新物品 {}", collect);

        }, CommonCmd.broadcastShowItem, "获得新物品");
    }

    ItemNode convert(ShowItemMessage showItemMessage) {
        return new ItemNode(showItemMessage.itemTypeId, showItemMessage.quantity);
    }
}