/*
 * ioGame
 * Copyright (C) 2021 - 2023  渔民小镇 （262610965@qq.com、luoyizhu@gmail.com） . All Rights Reserved.
 * # iohao.com . 渔民小镇
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package com.iohao.mmo.common.provide.kit;

import lombok.AccessLevel;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.FieldDefaults;

import java.util.HashMap;
import java.util.Map;

/**
 * @author 渔民小镇
 * @date 2023-08-15
 */
@Getter
@Setter
@FieldDefaults(level = AccessLevel.PRIVATE)
public class ItemNodeMap {
    final Map<String, ItemTypeNode> map = new HashMap<>();

    public void add(String itemTypeId, String name, String description) {
        var itemTypeNode = new ItemTypeNode(itemTypeId, name, description);

        map.put(itemTypeId, itemTypeNode);
    }

    public ItemTypeNode getItem(String itemId) {
        return map.get(itemId);
    }

}
