/*
 * ioGame
 * Copyright (C) 2021 - 2023  渔民小镇 （262610965@qq.com、luoyizhu@gmail.com） . All Rights Reserved.
 * # iohao.com . 渔民小镇
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package com.iohao.mmo.common.provide.kit;

import com.alibaba.fastjson2.JSONObject;
import lombok.experimental.UtilityClass;

/**
 * 客户端 - 物品通用工具
 *
 * @author 渔民小镇
 * @date 2023-08-15
 */
@UtilityClass
public class ItemTypeNodeKit {
    public ItemNodeMap itemNodeMap = new ItemNodeMap();

    public String toString(ItemNode itemNode) {
        var node = itemNodeMap.getItem(itemNode.itemId());
        String line = "\n物品信息：[%s x %s]；物品描述:%s";

        return String.format(line
                , node.name()
                , itemNode.quantity()
                , node.description()
        );
    }

    public JSONObject toJSON(String itemId) {
        var item = itemNodeMap.getItem(itemId);
        return JsonKit.toJSON(item);
    }
}
